/*

		Fonts Demo

		Keys: 0    = next font
					Exit = quits the font demo

		Originally by R2-D2 with the name "putstring.c" from 2007-09-20

		Changes for TMS by xyzzyx on 2009-08-22
		Support for TAPtoDate by xyzzyx on 2010-08-15
		Added FireBirdLib and KeyTranslate on 2010-11-18

*/

#include <tap.h>
// xyzzyx 101118
#ifdef _TMS_
#include "libFireBird.h"   // tested with FireBirdLib version "2010-11-14"
#endif

#define ID_FONTS 		0x80004711
#define PGM_NAME		"FontsDemo" 																																			// xyzzyx 100815
#define PGM_VERS		"V1.1b" 																																					// xyzzyx 100815
#define PGM_FULL		PGM_NAME " " PGM_VERS 																														// xyzzyx 100815

TAP_ID( 0x81AFFE07 ); 																																								// xyzzyx 100815 changed
TAP_PROGRAM_NAME(PGM_FULL); 																																					// xyzzyx 100815 changed
TAP_PROGRAM_VERSION(PGM_VERS); 																																				// xyzzyx 100815
TAP_AUTHOR_NAME("xyzzyx (R2-D2)");
TAP_DESCRIPTION("Demonstration of the 15 Fonts");
TAP_ETCINFO(__DATE__);


// char *strs[] XDATA = {																																							// xyzzyx 090822
char strs[12][32] = {																																									// xyzzyx 090822
	"  ! \" # $ % & ' ( ) * + , - . /",
	"0 1 2 3 4 5 6 7 8 9 : ; < = > ?",
	"@ A B C D E F G H I J K L M N O",
	"P Q R S T U V W X Y Z [ \\ ] ^ _",
	"` a b c d e f g h i j k l m n o",
	"p q r s t u v w x y z { | } ~ ",
	"               ",
	"               ",
	"               ",
	"               ",
	"               ",
	"               "
};

#define NUMSTRS (sizeof(strs)/sizeof(char*))

#define YSTART	(78)
#define YINC	(22)

int DoExit = 0;
word rgn = 0;
int font = 0;

void install()
{
	rgn = TAP_Osd_Create( 0, 0, 720, 576, 0, 0); //OSD_Flag_Plane2);
}

void draw(int f)
{
	int i, y = YSTART;
	char s[80];
	TAP_SPrint(s,"Font %d  ('0' for next, 'Exit' to quit)",f);
	TAP_Osd_PutString(rgn, 200, y, 500, s, COLOR_DarkBlue, COLOR_DarkYellow, 0, FNT_Size_1622, 1);
	y += YINC;
//	for(i = 0; i < (int) NUMSTRS; i++)																																// xyzzyx 090822
	for(i = 0; i < 12; i++)																																							// xyzzyx 090822
	{
		TAP_Osd_PutString(rgn, 200, y, 500, strs[i], COLOR_White, COLOR_Gray, f, FNT_Size_1622, 1);
		y += YINC;
	}
//	TAP_SPrint(s,																																											// xyzzyx 090822
//		"\x91[%d]Black \x91[%d]Red \x91[%d]Green \x91[%d]Blue \x91[%d]White \x91[%d]None",							// xyzzyx 090822
//		   COLOR_Black,  COLOR_Red,  COLOR_Green,  COLOR_Blue,  COLOR_White,  COLOR_None+1);						// xyzzyx 090822
//	TAP_Osd_PutString(rgn, 200, y, 500, s, COLOR_DarkBlue, COLOR_DarkYellow, 0, FNT_Size_1622, 1);		// xyzzyx 090822
	TAP_SPrint(s,"Font %d  ('0' for next, 'Exit' to quit)",f);																					// xyzzyx 090822
	TAP_Osd_PutString(rgn, 200, y, 500, s, COLOR_DarkBlue, COLOR_DarkYellow, 0, FNT_Size_1622, 1);			// xyzzyx 090822
	y += YINC;
	TAP_Osd_Sync(); 																																										// xyzzyx 090822
}

void remove()
{
	if(rgn)
		TAP_Osd_Delete(rgn);
}

dword TAP_EventHandler( word event, dword param1, dword param2 )
{
	UNUSED(param2);

	if(event == EVT_IDLE)
	{
		if(DoExit)
		{
			TAP_Print("Exiting...\n");
			remove();
			TAP_Exit();
		}
	}
	else if(event == EVT_KEY)
	{
		if(param1 == RKEY_0)
		{
			font++;
			if(font>=15)
				font = 0;
			draw(font);
		}
		else if(param1 == RKEY_Exit)
			DoExit = 1;
	}
	return param1;
}

/*****************************************************************************/
/* TAP_main */
/*****************************************************************************/

int TAP_Main(void)
{
// xyzzyx 101118
#ifdef _TMS_
	KeyTranslate(TRUE, &TAP_EventHandler);
#endif
	TAP_Print("Installing...\n");
	install();
	draw(font);
	return 1;
}
